package com.community.huiju.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.community.commom.mode.ResponseBean;
import com.community.huiju.exception.WisdomException;
import com.community.huiju.feign.IHKServer;
import com.community.huiju.feign.entity.PushPerson;
import com.community.huiju.model.TaUser;
import com.community.huiju.model.TaUserHk;
import com.community.huiju.model.TpEquipmentTree;
import com.community.huiju.model.TpUnitHkSetting;
import com.community.huiju.service.IEquipmentService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class EquipmentServiceImpl implements IEquipmentService {

    @Autowired
    private IHKServer ihkServer;

    @Override
    public String pushPerson(TpEquipmentTree tpEquipmentTree, TpUnitHkSetting unitHkSetting, TaUser user, TaUserHk taUserHk, Integer expirationTime) {

        // 人员信息
        PushPerson.PersonBean personBean = new PushPerson.PersonBean();
        personBean.setAppkey(tpEquipmentTree.getAppkey());
        personBean.setSecret(tpEquipmentTree.getSecret());
        personBean.setOpUserUuid(tpEquipmentTree.getOpUserUuid());
        personBean.setOpenapi_ip_port_http(tpEquipmentTree.getHttpServer());
        personBean.setDeptUuid(unitHkSetting.getDepartmentId());
        personBean.setPersonName(user.getUserName());
        personBean.setPersonNo(taUserHk.getHkPersonNo());
        personBean.setRemark(user.getLoginName());
        personBean.setCard(Long.valueOf(taUserHk.getHkCardNo()));
        personBean.setExpirationTime(expirationTime);

        PushPerson pushPerson = new PushPerson();
        pushPerson.setType(tpEquipmentTree.getFactory());
        pushPerson.setPerson(personBean);

        ResponseBean responseBean = ihkServer.pushPerson(JSONObject.toJSONString(pushPerson));
        if ("1".equals(responseBean.getCode())) {
            throw new WisdomException(responseBean.getMessage());
        }
        return JSONObject.toJSONString(responseBean.getData());
    }

    @Override
    public String addFace() {
        return null;
    }
}
